Index: /party/src/main/java/geniusweb/party/Party.java
===================================================================
--- /party/src/main/java/geniusweb/party/Party.java	(revision 53)
+++ /party/src/main/java/geniusweb/party/Party.java	(revision 1)
@@ -3,6 +3,5 @@
 import geniusweb.actions.Action;
 import geniusweb.connection.Connectable;
-import geniusweb.connection.ConnectionEnd;
-import geniusweb.inform.Inform;
+import geniusweb.party.inform.Inform;
 
 /**
@@ -15,24 +14,7 @@
  * your class may also be created only to call the getCapabilities function.
  * 
- * <h2>Short outline</h2> After the party is created (empty constructor) it is
- * first connected through a call to connect (from the {@link Connectable}
- * interface). The party can subscribe to receive {@link Inform} objects using
- * {@link ConnectionEnd#addListener(tudelft.utilities.listener.Listener)}. The
- * party can also send its actions using {@link ConnectionEnd#send(Object)}.
- * 
- * The {@link ConnectionEnd} allows the party to receive Inform objects and send
- * action objects.
- * 
- * Incoming Inform objects (eg "Settings" containing the profile, and
- * "yourturn") are notified to the party throught he notifyChange() call to the
- * party.
- * <p>
- * Outgoing Action objects (eg "Offer") are sent using the send() command.
- * 
- * Most parties extend {@link DefaultParty} to handle these connection details.
  * <p>
  * Technical details: normally a Party will be spawned inside a PartiesFactory,
- * and incoming/outgoing calls are routed through a websocket there. But in
- * testing the Connectable is often mocked.
+ * and incoming/outgoing calls are routed through a websocket there.
  * 
  */
@@ -52,13 +34,7 @@
 
 	/**
-	 * When this is called, the party must free up all its claimed resources
-	 * (memory, CPU, files, etc) immediately. This call can come in at any time
-	 * (when a negotiation is aborted early), even while your party is still
-	 * working on something else. Other parties for the next session may be
-	 * started within a few seconds after this request to your party. The exact
-	 * time is decided by the partyserver you use but typically 2 seconds. Not
-	 * respecting this call and continue using the system resources will
-	 * deteriorate performance of other parties running on the same machine,
-	 * which may be against the assignment/competition rules.
+	 * When this is called, the party should free up its resources and terminate
+	 * its threads. This call may come in at any time, eg when a negotiation is
+	 * aborted.
 	 */
 	void terminate();
Index: /party/src/main/java/geniusweb/party/inform/ActionDone.java
===================================================================
--- /party/src/main/java/geniusweb/party/inform/ActionDone.java	(revision 1)
+++ /party/src/main/java/geniusweb/party/inform/ActionDone.java	(revision 1)
@@ -0,0 +1,53 @@
+package geniusweb.party.inform;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.Action;
+
+/**
+ * Informs that someone did an action
+ */
+public class ActionDone implements Inform {
+
+	private final Action action;
+
+	@JsonCreator
+	public ActionDone(@JsonProperty("action") Action action) {
+		this.action = action;
+	}
+
+	public Action getAction() {
+		return action;
+	}
+
+	@Override
+	public String toString() {
+		return "ActionDone[" + action + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((action == null) ? 0 : action.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		ActionDone other = (ActionDone) obj;
+		if (action == null) {
+			if (other.action != null)
+				return false;
+		} else if (!action.equals(other.action))
+			return false;
+		return true;
+	}
+}
Index: /party/src/main/java/geniusweb/party/inform/Finished.java
===================================================================
--- /party/src/main/java/geniusweb/party/inform/Finished.java	(revision 1)
+++ /party/src/main/java/geniusweb/party/inform/Finished.java	(revision 1)
@@ -0,0 +1,61 @@
+package geniusweb.party.inform;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.issuevalue.Bid;
+
+/**
+ * Informs that the session is finished, and also contains the bid that was
+ * agreed on.
+ *
+ */
+public class Finished implements Inform {
+	private final Bid agreedBid;
+
+	/**
+	 * The session finished (can be for any reason).
+	 * 
+	 * @param agreedBid the bid that was finally agreed on; null if no
+	 *                  agreement.
+	 */
+	@JsonCreator
+	public Finished(@JsonProperty("agreedBid") Bid agreedBid) {
+		this.agreedBid = agreedBid;
+	}
+
+	public Bid getAgreement() {
+		return agreedBid;
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result
+				+ ((agreedBid == null) ? 0 : agreedBid.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Finished other = (Finished) obj;
+		if (agreedBid == null) {
+			if (other.agreedBid != null)
+				return false;
+		} else if (!agreedBid.equals(other.agreedBid))
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "Finished[" + agreedBid + "]";
+	}
+}
Index: /party/src/main/java/geniusweb/party/inform/Inform.java
===================================================================
--- /party/src/main/java/geniusweb/party/inform/Inform.java	(revision 1)
+++ /party/src/main/java/geniusweb/party/inform/Inform.java	(revision 1)
@@ -0,0 +1,23 @@
+package geniusweb.party.inform;
+
+import com.fasterxml.jackson.annotation.JsonAutoDetect;
+import com.fasterxml.jackson.annotation.JsonAutoDetect.Visibility;
+
+import geniusweb.party.Party;
+
+import com.fasterxml.jackson.annotation.JsonSubTypes;
+import com.fasterxml.jackson.annotation.JsonTypeInfo;
+
+/**
+ * base class of all information sent to the {@link Party}
+ */
+@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.WRAPPER_OBJECT)
+@JsonSubTypes({ @JsonSubTypes.Type(value = ActionDone.class),
+		@JsonSubTypes.Type(value = Inform.class),
+		@JsonSubTypes.Type(value = Settings.class),
+		@JsonSubTypes.Type(value = Finished.class),
+		@JsonSubTypes.Type(value = YourTurn.class) })
+@JsonAutoDetect(fieldVisibility = Visibility.ANY, getterVisibility = Visibility.NONE, setterVisibility = Visibility.NONE)
+public interface Inform {
+
+}
Index: /party/src/main/java/geniusweb/party/inform/Settings.java
===================================================================
--- /party/src/main/java/geniusweb/party/inform/Settings.java	(revision 1)
+++ /party/src/main/java/geniusweb/party/inform/Settings.java	(revision 1)
@@ -0,0 +1,104 @@
+package geniusweb.party.inform;
+
+import com.fasterxml.jackson.annotation.JsonCreator;
+import com.fasterxml.jackson.annotation.JsonProperty;
+
+import geniusweb.actions.PartyId;
+import geniusweb.progress.Progress;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+
+/**
+ * Informs a party about all settings for the upcoming negotiation session. This
+ * should be sent to a party one time, so that the party knows the situation.
+ *
+ */
+public class Settings implements Inform {
+	private ProfileRef profile;
+	private ProtocolRef protocol;
+	private Progress progress;
+	private PartyId id;
+
+	@JsonCreator
+	public Settings(@JsonProperty("id") PartyId id,
+			@JsonProperty("profile") ProfileRef profile,
+			@JsonProperty("protocol") ProtocolRef protocol,
+			@JsonProperty("progress") Progress progress) {
+		if (profile == null || protocol == null || progress == null) {
+			throw new IllegalArgumentException(
+					"party, profile, protocol and progress must be not null.");
+		}
+		this.profile = profile;
+		this.protocol = protocol;
+		this.progress = progress;
+		this.id = id;
+	}
+
+	public ProfileRef getProfile() {
+		return profile;
+	}
+
+	public ProtocolRef getProtocol() {
+		return protocol;
+	}
+
+	public Progress getProgress() {
+		return progress;
+	}
+
+	public PartyId getID() {
+		return id;
+	}
+
+	@Override
+	public String toString() {
+		return "Settings[" + id + "," + profile + "," + protocol + ","
+				+ progress + "]";
+	}
+
+	@Override
+	public int hashCode() {
+		final int prime = 31;
+		int result = 1;
+		result = prime * result + ((id == null) ? 0 : id.hashCode());
+		result = prime * result + ((profile == null) ? 0 : profile.hashCode());
+		result = prime * result
+				+ ((progress == null) ? 0 : progress.hashCode());
+		result = prime * result
+				+ ((protocol == null) ? 0 : protocol.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		Settings other = (Settings) obj;
+		if (id == null) {
+			if (other.id != null)
+				return false;
+		} else if (!id.equals(other.id))
+			return false;
+		if (profile == null) {
+			if (other.profile != null)
+				return false;
+		} else if (!profile.equals(other.profile))
+			return false;
+		if (progress == null) {
+			if (other.progress != null)
+				return false;
+		} else if (!progress.equals(other.progress))
+			return false;
+		if (protocol == null) {
+			if (other.protocol != null)
+				return false;
+		} else if (!protocol.equals(other.protocol))
+			return false;
+		return true;
+	}
+
+}
Index: /party/src/main/java/geniusweb/party/inform/YourTurn.java
===================================================================
--- /party/src/main/java/geniusweb/party/inform/YourTurn.java	(revision 1)
+++ /party/src/main/java/geniusweb/party/inform/YourTurn.java	(revision 1)
@@ -0,0 +1,28 @@
+package geniusweb.party.inform;
+
+/**
+ * Informs a party that he has the turn and can choose the next action.
+ */
+public class YourTurn implements Inform {
+
+	@Override
+	public int hashCode() {
+		return 1;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		return true;
+	}
+
+	@Override
+	public String toString() {
+		return "YourTurn";
+	}
+}
Index: /party/src/test/java/geniusweb/party/CapabilitiesTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 53)
+++ /party/src/test/java/geniusweb/party/CapabilitiesTest.java	(revision 1)
@@ -4,7 +4,7 @@
 
 import java.io.IOException;
+import java.net.URI;
 import java.net.URISyntaxException;
 import java.util.Arrays;
-import java.util.Collections;
 import java.util.List;
 
@@ -18,6 +18,6 @@
 import com.fasterxml.jackson.databind.ObjectMapper;
 
-import geniusweb.profile.PartialOrdering;
-import geniusweb.profile.utilityspace.LinearAdditive;
+import geniusweb.party.Capabilities;
+import geniusweb.references.ProtocolRef;
 import tudelft.utilities.junit.GeneralTests;
 
@@ -25,20 +25,17 @@
 
 	private Capabilities capabilities1, capabilities1a, capabilities2,
-			capabilities3, capabilities4;
-	private String asJson = "{\"behaviours\":[\"SAOP\"],\"profiles\":[\"geniusweb.profile.utilityspace.LinearAdditive\"]}";
+			capabilities3;
+	private String asJson = "{\"protocols\":[\"ws:localhost/protocol1\"]}";
 
 	@Before
 	public void before() throws URISyntaxException {
-		capabilities1 = new Capabilities(Sets.newSet("SAOP"),
-				Collections.singleton(LinearAdditive.class));
-		capabilities1a = new Capabilities(Sets.newSet("SAOP"),
-				Collections.singleton(LinearAdditive.class));
-		capabilities2 = new Capabilities(Sets.newSet("SEB"),
-				Collections.singleton(LinearAdditive.class));
-		capabilities3 = new Capabilities(Sets.newSet("SEB", "SAOP"),
-				Collections.singleton(LinearAdditive.class));
-		capabilities4 = new Capabilities(Sets.newSet("SAOP"),
-				Collections.singleton(PartialOrdering.class));
-
+		capabilities1 = new Capabilities(Sets
+				.newSet(new ProtocolRef(new URI("ws:localhost/protocol1"))));
+		capabilities1a = new Capabilities(Sets
+				.newSet(new ProtocolRef(new URI("ws:localhost/protocol1"))));
+		capabilities2 = new Capabilities(Sets
+				.newSet(new ProtocolRef(new URI("ws:localhost/protocol2"))));
+		capabilities3 = new Capabilities(Sets
+				.newSet(new ProtocolRef(new URI("ws:localhost/protocol3"))));
 	}
 
@@ -46,6 +43,5 @@
 	public List<List<Capabilities>> getGeneralTestData() {
 		return Arrays.asList(Arrays.asList(capabilities1, capabilities1a),
-				Arrays.asList(capabilities2), Arrays.asList(capabilities3),
-				Arrays.asList(capabilities4));
+				Arrays.asList(capabilities2), Arrays.asList(capabilities3));
 	}
 
@@ -53,13 +49,12 @@
 	public List<String> getGeneralTestStrings() {
 		return Arrays.asList(
-				"Capabilities.*geniusweb.profile.utilityspace.LinearAdditive.*SAOP.*",
-				"Capabilities.*geniusweb.profile.utilityspace.LinearAdditive.*SEB.*",
-				"Capabilities.*geniusweb.profile.utilityspace.LinearAdditive.*SEB.*SAOP.*",
-				"Capabilities.*geniusweb.profile.PartialOrdering.*SAOP.*");
+				"Capabilities.*Protocols=.*ProtocolRef.*protocol1.*",
+				"Capabilities.*Protocols=.*ProtocolRef.*protocol2.*",
+				"Capabilities.*Protocols=.*ProtocolRef.*protocol3.*");
 	}
 
 	@Test(expected = IllegalArgumentException.class)
 	public void nullTest() throws URISyntaxException {
-		new Capabilities(null, Collections.singleton(LinearAdditive.class));
+		new Capabilities(null);
 	}
 
@@ -82,8 +77,3 @@
 	}
 
-	@Test
-	public void behaviours() {
-		assertEquals(Sets.newSet("SEB", "SAOP"), capabilities3.getBehaviours());
-	}
-
 }
Index: /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java	(revision 1)
+++ /party/src/test/java/geniusweb/party/inform/ActionDoneTest.java	(revision 1)
@@ -0,0 +1,101 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.Accept;
+import geniusweb.actions.PartyId;
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.party.inform.ActionDone;
+import geniusweb.party.inform.Inform;
+import tudelft.utilities.junit.GeneralTests;
+
+public class ActionDoneTest extends GeneralTests<ActionDone> {
+
+	private ActionDone finished1, finished1a, finished2;
+
+	private String asJson = "{\"ActionDone\":{\"action\":{\"accept\":{\"actor\":\"me\",\"bid\":{\"issuevalues\":{\"issue3\":9012,\"issue2\":1,\"issue1\":\"b\"}}}}}}";
+
+	private PartyId me = new PartyId("me");
+
+	@Before
+	public void before() throws URISyntaxException {
+		final String ISSUE1 = "issue1";
+		final String ISSUE2 = "issue2";
+		final Value VALUE1 = new DiscreteValue("value1");
+		final Value VALUE2 = new NumberValue("10");
+
+		Map<String, Value> issuevalues = new HashMap<>();
+		issuevalues.put(ISSUE1, new DiscreteValue("b"));
+		issuevalues.put(ISSUE2, new NumberValue(BigDecimal.ONE));
+		issuevalues.put("issue3", new NumberValue(new BigDecimal("9012")));
+		Bid bid = new Bid(issuevalues);
+
+		Map<String, Value> issuevaluesb = new HashMap<>();
+		issuevaluesb.put(ISSUE1, new DiscreteValue("b"));
+		issuevaluesb.put(ISSUE2, new NumberValue(BigDecimal.ONE));
+		Bid bidb = new Bid(issuevaluesb);
+
+		// bidc and bidd have values swapped, so different issuevalues.
+		Map<String, Value> issuevaluesc = new HashMap<>();
+		issuevaluesc.put(ISSUE1, VALUE1);
+		issuevaluesc.put(ISSUE2, VALUE2);
+
+		finished1 = new ActionDone(new Accept(me, bid));
+		finished1a = new ActionDone(new Accept(me, bid));
+		finished2 = new ActionDone(new Accept(me, bidb));
+	}
+
+	@Override
+	public List<List<ActionDone>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(finished1, finished1a),
+				Arrays.asList(finished2));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("ActionDone.*Accept.*", "ActionDone.*Accept.*");
+	}
+
+	@Test
+	public void nullTest() throws URISyntaxException {
+		new ActionDone(null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(finished1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		ActionDone p = (ActionDone) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(finished1, p);
+	}
+
+}
Index: /party/src/test/java/geniusweb/party/inform/FinishedTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/FinishedTest.java	(revision 1)
+++ /party/src/test/java/geniusweb/party/inform/FinishedTest.java	(revision 1)
@@ -0,0 +1,101 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.math.BigDecimal;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.issuevalue.Bid;
+import geniusweb.issuevalue.DiscreteValue;
+import geniusweb.issuevalue.NumberValue;
+import geniusweb.issuevalue.Value;
+import geniusweb.party.inform.Finished;
+import geniusweb.party.inform.Inform;
+import tudelft.utilities.junit.GeneralTests;
+
+public class FinishedTest extends GeneralTests<Finished> {
+
+	private Finished finished1, finished1a, finished2, finished3;
+
+	private String asJson = "{\"Finished\":{\"agreedBid\":{\"issuevalues\":{\"issue3\":9012,\"issue2\":1,\"issue1\":\"b\"}}}}";
+
+	@Before
+	public void before() throws URISyntaxException {
+		final String ISSUE1 = "issue1";
+		final String ISSUE2 = "issue2";
+		final Value VALUE1 = new DiscreteValue("value1");
+		final Value VALUE2 = new NumberValue("10");
+
+		Map<String, Value> issuevalues = new HashMap<>();
+		issuevalues.put(ISSUE1, new DiscreteValue("b"));
+		issuevalues.put(ISSUE2, new NumberValue(BigDecimal.ONE));
+		issuevalues.put("issue3", new NumberValue(new BigDecimal("9012")));
+		Bid bid = new Bid(issuevalues);
+
+		Map<String, Value> issuevaluesb = new HashMap<>();
+		issuevaluesb.put(ISSUE1, new DiscreteValue("b"));
+		issuevaluesb.put(ISSUE2, new NumberValue(BigDecimal.ONE));
+		Bid bidb = new Bid(issuevaluesb);
+
+		// bidc and bidd have values swapped, so different issuevalues.
+		Map<String, Value> issuevaluesc = new HashMap<>();
+		issuevaluesc.put(ISSUE1, VALUE1);
+		issuevaluesc.put(ISSUE2, VALUE2);
+		Bid bidc = new Bid(issuevaluesc);
+
+		finished1 = new Finished(bid);
+		finished1a = new Finished(bid);
+		finished2 = new Finished(bidb);
+		finished3 = new Finished(bidc);
+	}
+
+	@Override
+	public List<List<Finished>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(finished1, finished1a),
+				Arrays.asList(finished2), Arrays.asList(finished3));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("Finished.*issue3=9012.*issue2=1.*issue1=\"b\".*",
+				"Finished.*issue2=1.*issue1=\"b\".*",
+				"Finished.*issue2=10.*issue1=\"value1\".*");
+	}
+
+	@Test
+	public void nullTest() throws URISyntaxException {
+		new Finished(null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(finished1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Finished p = (Finished) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(finished1, p);
+	}
+
+}
Index: /party/src/test/java/geniusweb/party/inform/NegotiationInfoTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/NegotiationInfoTest.java	(revision 1)
+++ /party/src/test/java/geniusweb/party/inform/NegotiationInfoTest.java	(revision 1)
@@ -0,0 +1,116 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URI;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.Date;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.actions.PartyId;
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.Settings;
+import geniusweb.progress.ProgressRounds;
+import geniusweb.references.PartyRef;
+import geniusweb.references.ProfileRef;
+import geniusweb.references.ProtocolRef;
+import tudelft.utilities.junit.GeneralTests;
+
+public class NegotiationInfoTest extends GeneralTests<Settings> {
+
+	private PartyId id = new PartyId("party1");
+	private PartyId id2 = new PartyId("party2");
+
+	private final String asJson = "{\"Settings\":"
+			+ "{\"id\":\"party1\",\"profile\":\"ws:profile1\","
+			+ "\"protocol\":\"ws:localhost/protocol1\","
+			+ "\"progress\":{\"rounds\":{\"duration\":10,\"currentRound\":0,\"endtime\":999}}}}";
+
+	private Settings negoinfo1;
+	private Settings negoinfo1a;
+	private Settings negoinfo2;
+	private Settings negoinfo3;
+	private Settings negoinfo4;
+	private final Date date = new Date(999);
+
+	@Before
+	public void before() throws URISyntaxException, JsonParseException,
+			JsonMappingException, IOException {
+		// we can't mock because we want to test the serializer
+		ObjectMapper jackson = new ObjectMapper();
+		ProfileRef profile1 = new ProfileRef(new URI("ws:profile1"));
+		// jackson.readValue(serialized, Profile.class);
+
+		ProtocolRef protocol1 = new ProtocolRef(
+				new URI("ws:localhost/protocol1"));
+		ProtocolRef protocol1a = new ProtocolRef(
+				new URI("ws:localhost/protocol1"));
+		ProtocolRef protocol2 = new ProtocolRef(
+				new URI("ws:localhost/protocol2"));
+		ProgressRounds progress1 = new ProgressRounds(10, 0, date);
+		ProgressRounds progress1a = new ProgressRounds(10, 0, date);
+		ProgressRounds progress2 = new ProgressRounds(12, 0, date);
+
+		negoinfo1 = new Settings(id, profile1, protocol1, progress1);
+		negoinfo1a = new Settings(id, profile1, protocol1a, progress1a);
+		negoinfo2 = new Settings(id, profile1, protocol2, progress1);
+		negoinfo3 = new Settings(id, profile1, protocol1, progress2);
+		negoinfo4 = new Settings(id2, profile1, protocol1, progress2);
+	}
+
+	@Override
+	public List<List<Settings>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(negoinfo1, negoinfo1a),
+				Arrays.asList(negoinfo2), Arrays.asList(negoinfo3),
+				Arrays.asList(negoinfo4));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList(
+				"Settings.*party1.*ProtocolRef.*protocol1.*ProgressRounds.*0.*10.*",
+				"Settings.*party1.*ProtocolRef.*protocol2.*ProgressRounds.*0.*10.*",
+				"Settings.*party1.*ProtocolRef.*protocol1.*ProgressRounds.*0.*12.*",
+				"Settings.*party2.*ProtocolRef.*protocol1.*ProgressRounds.*0.*12.*");
+
+	}
+
+	@Test
+	public void smokeTest() throws URISyntaxException {
+		new PartyRef(new URI("ws:localhost"));
+	}
+
+	@Test(expected = IllegalArgumentException.class)
+	public void nullTest() throws URISyntaxException {
+		new PartyRef((URI) null);
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(negoinfo1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		Settings p = (Settings) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(negoinfo1, p);
+	}
+
+}
Index: /party/src/test/java/geniusweb/party/inform/YourTurnTest.java
===================================================================
--- /party/src/test/java/geniusweb/party/inform/YourTurnTest.java	(revision 1)
+++ /party/src/test/java/geniusweb/party/inform/YourTurnTest.java	(revision 1)
@@ -0,0 +1,72 @@
+package geniusweb.party.inform;
+
+import static org.junit.Assert.assertEquals;
+
+import java.io.IOException;
+import java.net.URISyntaxException;
+import java.util.Arrays;
+import java.util.List;
+
+import org.junit.Before;
+import org.junit.Test;
+
+import com.fasterxml.jackson.core.JsonParseException;
+import com.fasterxml.jackson.core.JsonProcessingException;
+import com.fasterxml.jackson.databind.JsonMappingException;
+import com.fasterxml.jackson.databind.ObjectMapper;
+
+import geniusweb.party.inform.Inform;
+import geniusweb.party.inform.YourTurn;
+import tudelft.utilities.junit.GeneralTests;
+
+public class YourTurnTest extends GeneralTests<YourTurn> {
+
+	private YourTurn yourturn1, yourturn1b;
+
+	private String asJson = "{\"YourTurn\":{}}";
+
+	private YourTurn yourturnb;
+
+	@Before
+	public void before() throws URISyntaxException {
+
+		yourturn1 = new YourTurn();
+		yourturn1b = new YourTurn();
+		yourturnb = new YourTurn() {
+			@Override
+			public int hashCode() {
+				return 2;
+			}
+		};
+	}
+
+	@Override
+	public List<List<YourTurn>> getGeneralTestData() {
+		return Arrays.asList(Arrays.asList(yourturn1, yourturn1b),
+				Arrays.asList(yourturnb));
+	}
+
+	@Override
+	public List<String> getGeneralTestStrings() {
+		return Arrays.asList("YourTurn*", "YourTurn*");
+	}
+
+	@Test
+	public void testSerialize() throws JsonProcessingException {
+		ObjectMapper jackson = new ObjectMapper();
+
+		String json = jackson.writeValueAsString(yourturn1);
+		System.out.println(json);
+		assertEquals(asJson, json);
+	}
+
+	@Test
+	public void testDeserialize()
+			throws JsonParseException, JsonMappingException, IOException {
+		ObjectMapper jackson = new ObjectMapper();
+		YourTurn p = (YourTurn) jackson.readValue(asJson, Inform.class);
+		System.out.println(p);
+		assertEquals(yourturn1, p);
+	}
+
+}
Index: /profile/.classpath
===================================================================
--- /profile/.classpath	(revision 1)
+++ /profile/.classpath	(revision 1)
@@ -0,0 +1,27 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="src" output="target/classes" path="src/main/java">
+		<attributes>
+			<attribute name="optional" value="true"/>
+			<attribute name="maven.pomderived" value="true"/>
+		</attributes>
+	</classpathentry>
+	<classpathentry kind="src" output="target/test-classes" path="src/test/java">
+		<attributes>
+			<attribute name="optional" value="true"/>
+			<attribute name="maven.pomderived" value="true"/>
+			<attribute name="test" value="true"/>
+		</attributes>
+	</classpathentry>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.8">
+		<attributes>
+			<attribute name="maven.pomderived" value="true"/>
+		</attributes>
+	</classpathentry>
+	<classpathentry kind="con" path="org.eclipse.m2e.MAVEN2_CLASSPATH_CONTAINER">
+		<attributes>
+			<attribute name="maven.pomderived" value="true"/>
+		</attributes>
+	</classpathentry>
+	<classpathentry kind="output" path="target/classes"/>
+</classpath>
Index: /profile/.project
===================================================================
--- /profile/.project	(revision 1)
+++ /profile/.project	(revision 1)
@@ -0,0 +1,23 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>profile</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.m2e.core.maven2Builder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+		<nature>org.eclipse.m2e.core.maven2Nature</nature>
+	</natures>
+</projectDescription>
Index: /profile/.settings/org.eclipse.core.resources.prefs
===================================================================
--- /profile/.settings/org.eclipse.core.resources.prefs	(revision 1)
+++ /profile/.settings/org.eclipse.core.resources.prefs	(revision 1)
@@ -0,0 +1,4 @@
+eclipse.preferences.version=1
+encoding//src/main/java=UTF-8
+encoding//src/test/java=UTF-8
+encoding/<project>=UTF-8
Index: /profile/.settings/org.eclipse.jdt.core.prefs
===================================================================
--- /profile/.settings/org.eclipse.jdt.core.prefs	(revision 1)
+++ /profile/.settings/org.eclipse.jdt.core.prefs	(revision 1)
@@ -0,0 +1,6 @@
+eclipse.preferences.version=1
+org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.8
+org.eclipse.jdt.core.compiler.compliance=1.8
+org.eclipse.jdt.core.compiler.problem.forbiddenReference=warning
+org.eclipse.jdt.core.compiler.release=disabled
+org.eclipse.jdt.core.compiler.source=1.8
Index: /profile/.settings/org.eclipse.m2e.core.prefs
===================================================================
--- /profile/.settings/org.eclipse.m2e.core.prefs	(revision 1)
+++ /profile/.settings/org.eclipse.m2e.core.prefs	(revision 1)
@@ -0,0 +1,4 @@
+activeProfiles=
+eclipse.preferences.version=1
+resolveWorkspaceProjects=true
+version=1
